VERSION 5.00
Begin VB.Form CSPSample 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Using Send Personally Component"
   ClientHeight    =   4560
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6765
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4560
   ScaleWidth      =   6765
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox FieldText 
      Height          =   3135
      Left            =   120
      MultiLine       =   -1  'True
      TabIndex        =   4
      Text            =   "CSPSample.frx":0000
      Top             =   1320
      Width           =   6495
   End
   Begin VB.TextBox FieldSubject 
      Height          =   285
      Left            =   720
      TabIndex        =   3
      Text            =   "Test message for %NAME% (%EMAIL%)"
      Top             =   960
      Width           =   5895
   End
   Begin VB.TextBox FieldTo 
      Height          =   285
      Left            =   720
      TabIndex        =   2
      Text            =   "Some Recipient <somerecipient@company.com>; Another Recipient <another@company.com>"
      Top             =   600
      Width           =   5895
   End
   Begin VB.CommandButton DeliverMail 
      Caption         =   "Send This message personally"
      Height          =   375
      Left            =   120
      TabIndex        =   5
      Top             =   120
      Width           =   6495
   End
   Begin VB.Label LabelSubj 
      Caption         =   "Subject:"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   960
      Width           =   495
   End
   Begin VB.Label LabelTo 
      Caption         =   "To:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   600
      Width           =   495
   End
End
Attribute VB_Name = "CSPSample"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim OlApplication As Outlook.Application
Dim WithEvents TMItem As TMMailItem
Attribute TMItem.VB_VarHelpID = -1

Private Sub DeliverMail_Click()
On Error GoTo ErrorHandler

    Dim OutlookMsg As MailItem

    ' Create object Outlook.Application
    Set OlApplication = CreateObject("Outlook.Application")
   
    ' Create a new message
    Set OutlookMsg = OlApplication.CreateItem(olMailItem)
        
    ' Put data into the message's field
    OutlookMsg.To = FieldTo.Text
    OutlookMsg.Subject = FieldSubject.Text
    OutlookMsg.Body = FieldText.Text

    ' Create object SendPerson.TMMailItem
    Set TMItem = CreateObject("SendPerson.TMMailItem")

    ' Put reference to OutlookMsg into the SendPerson.TMMailItem
    Set TMItem.Item = OutlookMsg
    
    ' Create the macros used in the message subject and message body fields. 
    TMItem.AddMacros "NAME", dfRecipientName, True
    TMItem.AddMacros "EMAIL", dfRecipientEmail, True
    TMItem.AddMacros "FIRSTNAME", dfRecipientFirstName, True
    TMItem.AddMacros "LASTNAME", dfRecipientLastName, True
    
    ' Add custom macro
    TMItem.AddMacros "JOB_TITLE", dfOwnerEvaluate, True

    ' Send message
    TMItem.SendPersonally 0, True, "", ""

    ' Delete source message
    OutlookMsg.Delete

ErrorHandlerExit:
   Exit Sub
ErrorHandler:
   MsgBox Err.Description, vbAbortRetryIgnore, "CSP Using Sample (Error)"
   Resume ErrorHandlerExit
End Sub

' Calculate the values of the custom macros
Private Sub TMItem_EvaluateMacros(ByVal PersonData As SendPersonLib.ITMPersonData, ByVal Macros As SendPersonLib.ITMMacros)
On Error GoTo ErrorHandler
    
    Dim ContactsFolder As MAPIFolder
    Dim ContactItems As Items
    Dim RecipientContact As ContactItem
    
    ' Check the macro to be calculated
    If Macros.Name = "JOB_TITLE" Then
    
        ' Look for Item "Contact" in the contact folder
        Set ContactsFolder = OlApplication.Session.GetDefaultFolder(olFolderContacts)
        Set ContactItems = ContactsFolder.Items
        Set RecipientContact = ContactItems.Find("[Email1Address]=" & PersonData.Address)
        
        ' Put the found data into the "Value" property
        Macros.Value = RecipientContact.JobTitle
    End If

ErrorHandlerExit:
   Exit Sub
ErrorHandler:
   Macros.Value = "[Macros Evaluation Error=(" & Err.Description & ")]"
   Resume ErrorHandlerExit
End Sub
